/*!
 * @file media_container.h
  *  Manages the media files

*/

#ifndef _MEDIA_CONTAINER
#define _MEDIA_CONTAINER

/* FFmpeg */
#include "ffmpeg/avformat.h"

#include "glincl.h"

/* include base_object.h since all classes are derived from this one */
#include "base_object.h"

/* using namespace std is default, this needs to be here */
using namespace std;

class MediaContainer : public BaseObject
{

private:

	char* filename;
	int current_frame;

	AVFormatContext* format_context;
	AVCodecContext* codec_context;
	AVCodec* codec;
	AVFrame* frame;
	AVPacket packet;
	
	int num_bytes;
	int video_stream;

public:

  MediaContainer(const char* filename);
  ~MediaContainer();

	GLuint getFrame(int frame_number);
	GLuint getNextFrame();
	void loadMedia(char* filename);
	
	int getHeight();
	int getWidth();
	int getFrameRate();
	void getStream(/* stream */);

};



#endif /* _MEDIA_CONTAINER */
